SystemOrganization addCategory: #Deprecated14!

MessageSet subclass: #ChangedMessageSet
	instanceVariableNames: 'changeSet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deprecated14'!

!ChangedMessageSet commentStamp: 'BernardoContreras 8/1/2011 19:50' prior: 0!
DEPRECATED. see http://code.google.com/p/pharo/issues/detail?id=4574
A ChangedMessageSet is a message set associated with a change-set; it bears an entry for every method added or changed in the change set, as well as for every class-comment of which the change-set bears a note.!

!ChangedMessageSet class methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 8/1/2011 19:53'!
openFor: aChangeSet
	"Open up a ChangedMessageSet browser on the given change set; this is a conventional message-list browser whose message-list consists of all the methods in aChangeSet.  After any method submission, the message list is refigured, making it plausibly dynamic"

	| messageSet |
	
	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	messageSet := aChangeSet changedMessageList select: [ :each | each isValid].
	self 
		openMessageList: messageSet 
		name: 'Methods in Change Set ', aChangeSet name
		autoSelect: nil
		changeSet: aChangeSet! !

!ChangedMessageSet class methodsFor: 'as yet unclassified' stamp: 'BernardoContreras 8/1/2011 19:53'!
openMessageList: messageList name: labelString autoSelect: autoSelectString changeSet: aChangeSet
	| messageSet |

	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	messageSet := self messageList: messageList.
	messageSet changeSet: aChangeSet.
	messageSet autoSelectString: autoSelectString.
	self openAsMorph: messageSet name: labelString! !

!ChangedMessageSet class methodsFor: 'tools registry' stamp: 'BernardoContreras 8/1/2011 19:54'!
registerToolsOn: registry

	"Add ourselves to registry. See [Smalltalk tools]" 
	self deprecated: 'issue 4574' on: '1 August, 2011' in: 'Pharo1.4'.
	registry register: self as: #changedMessageSet
! !

!ChangedMessageSet methodsFor: 'initialization' stamp: 'sd 11/20/2005 21:26'!
changeSet: aChangeSet
	changeSet := aChangeSet! !

!ChangedMessageSet methodsFor: 'acceptance' stamp: 'md 2/20/2006 18:42'!
contents: aString notifying: aController
	"Accept the string as new source for the current method, and make certain the annotation pane gets invalidated"

	| existingSelector existingClass superResult newSelector |
	existingSelector := self selectedMessageName.
	existingClass := self selectedClassOrMetaClass.

	superResult := super contents: aString notifying: aController.
	superResult ifTrue:  "succeeded"
		[newSelector := existingClass parserClass new parseSelector: aString.
		newSelector ~= existingSelector
			ifTrue:   "Selector changed -- maybe an addition"
				[self reformulateList.
				self changed: #messageList.
				self messageList doWithIndex:
					[:aMethodReference :anIndex |
						(aMethodReference actualClass == existingClass and:
									[aMethodReference methodSymbol == newSelector])
							ifTrue:
								[self messageListIndex: anIndex]]]].
	^ superResult! !

!ChangedMessageSet methodsFor: 'message list' stamp: 'sw 1/28/2001 20:59'!
growable
	"Answer whether the receiver can be changed by manual additions & deletions"

	^ false! !

!ChangedMessageSet methodsFor: 'reformulation' stamp: 'StephaneDucasse 1/7/2011 17:42'!
reformulateList
	"Reformulate the message list of the receiver"

	self initializeMessageList: 
		(changeSet changedMessageList select: [:each | each isValid])
! !
